
#define	STRICT

#include "foo_dsp_ssrc.h"
#include "Config.h"
#include <atlstr.h>;

const int	List_SampleRate[]=
{8000, 11025, 12000, 16000, 22050, 24000, 32000, 44100, 48000, 64000, 88200, 96000, 128000, 176400, 192000};

const WCHAR* List_Quality[]= {
	L"", 
	L"Default", L"PLAY MP3 Low", 
	L"8bit Low", L"8bit Normal", L"8bit High", 
	L"16bit Low", L"16bit Normal", L"16bit High", 
	L"20bit Low", L"20bit Normal", L"20bit High", 
	L"24bit Low", L"24bit Normal", L"24bit High", 
	L"32bit Low", L"32bit Normal", L"32bit High", 
	L"otachan Low", L"otachan Normal", L"otachan High", L"otachan Top", L"otachan Ultra"
};

const int list_quality_preset[] = {
	151, 1,  100, 1,   4166, 1,      1, 
	103, 0, 5050, 1, 229025, 1,      1, 
	 55, 0, 2000, 1,  92971, 1,      1, 
	 55, 1,  100, 1,   4166, 1,      1, 
	 55, 1,   25, 1,   1041, 1,      1, 
	103, 0, 2000, 1,  92971, 1,      1, 
	103, 1,  100, 1,   4166, 1,      1, 
	103, 1,   25, 1,   1041, 1,      1, 
	127, 0, 2000, 1,  92971, 1,      1, 
	127, 1,  100, 1,   4166, 1,      1, 
	127, 1,   25, 1,   1041, 1,      1, 
	151, 0, 2000, 1,  92971, 1,      1, 
	151, 1,  100, 1,   4166, 1,      1, 
	151, 1,   25, 1,   1041, 1,      1, 
	199, 0, 2000, 1,  92971, 1,      1, 
	199, 1,  100, 1,   4166, 1,      1, 
	199, 1,   25, 1,   1041, 1,      1, 
	 96, 1, 4000, 0, 160000, 1,   1024, 
	120, 1,   50, 0,   2000, 1,  16384, 
	170, 1,   50, 0,   2000, 1,  16384, 
	170, 1,   50, 0,   2000, 1,  65536, 
	200, 1,   25, 0,   1000, 1, 262144
};

DialogOption::DialogOption(HWND hParentWnd, PARAM_GLOBAL* _ParamGlobal) :
	SDialog(hParentWnd, IDD_CONFIG)
{
	ParamGlobal = _ParamGlobal;
}

DialogOption::~DialogOption(void)
{
	delete Quality;
}

static const int chkids[] = {
	IDC_OK_FREQ_31, 
	IDC_OK_FREQ_1, -1, IDC_OK_FREQ_3, 
	IDC_OK_FREQ_4, -1, IDC_OK_FREQ_6, 
	IDC_OK_FREQ_7, -1, IDC_OK_FREQ_9, 
	IDC_OK_FREQ_10, IDC_OK_FREQ_11, IDC_OK_FREQ_12, 
	IDC_OK_FREQ_13, IDC_OK_FREQ_14, IDC_OK_FREQ_15, 
	IDC_OK_FREQ_16, IDC_OK_FREQ_17, IDC_OK_FREQ_18, 
	IDC_OK_FREQ_19, IDC_OK_FREQ_20, IDC_OK_FREQ_21, 
	IDC_OK_FREQ_22, IDC_OK_FREQ_23, IDC_OK_FREQ_24, 
	IDC_OK_FREQ_25, IDC_OK_FREQ_26, IDC_OK_FREQ_27, 
	IDC_OK_FREQ_28, IDC_OK_FREQ_29, IDC_OK_FREQ_30
};


bool
DialogOption::WmInitDialog(Org_Mes* OrgMes, HWND hwnd, LONG_PTR lInitParam)
{
	OrgMes->ExecMessage = true;
	SDialog::WmInitDialog(OrgMes, hwnd, lInitParam);

	Quality_hwnd = GetDlgItem(IDC_QUALITY);
	Quality = new SComboBox(this, Quality_hwnd);

	for(int Idx = 0; Idx < 23; Idx++) {
		Quality->AddString(List_Quality[Idx]);
	}

	//Quality->SetCurSel(ParamGlobal->quality);

	{
		TCHAR buf[32];
		memo_q_AA = ParamGlobal->q_sep_AA;
		::SetWindowText(GetDlgItem(IDC_Q_AA), _itot(memo_q_AA, buf, 10));
		memo_q_DF_HZC = ParamGlobal->q_sep_DF_HZC;
		::SendMessage(GetDlgItem(IDC_Q_DF_HZC), BM_SETCHECK, (memo_q_DF_HZC & 1), 0);
		memo_q_DF_HZ = ParamGlobal->q_sep_DF_HZ;
		::SetWindowText(GetDlgItem(IDC_Q_DF_HZ), _itot(memo_q_DF_HZ, buf, 10));
		memo_q_DF_MFSC = ParamGlobal->q_sep_DF_MFSC;
		::SendMessage(GetDlgItem(IDC_Q_DF_MFSC), BM_SETCHECK, (memo_q_DF_MFSC & 1), 0);
		memo_q_DF_MFS = ParamGlobal->q_sep_DF_MFS;
		::SetWindowText(GetDlgItem(IDC_Q_DF_MFS), _itot(memo_q_DF_MFS, buf, 10));
		memo_q_DF_PRIFAST = ParamGlobal->q_sep_DF_PRIFAST;
		::SendMessage(GetDlgItem(IDC_Q_DF_PRIFAST), BM_SETCHECK, (memo_q_DF_PRIFAST & 1), 0);
		memo_q_FFTFIRLEN = ParamGlobal->q_sep_FFTFIRLEN;
		::SetWindowText(GetDlgItem(IDC_Q_FFTFIRLEN), _itot(memo_q_FFTFIRLEN, buf, 10));

		unsigned int bt = ParamGlobal->srates;
		for(int a = 0; a < 31; a++, bt >>= 1){
			if(chkids[a] != -1)
				::SendMessage(GetDlgItem(chkids[a]), BM_SETCHECK, (bt & 1), 0);
		};

		::SetWindowText(GetDlgItem(IDC_FREQ_FREE), _itot(ParamGlobal->srate_free, buf, 10));
		::SendMessage(GetDlgItem(IDC_CON_INFO), BM_SETCHECK, ParamGlobal->info_con, 0);
	};

	return true;
}

void
DialogOption::CmOk(void)
{
	ParamGlobal->q_sep_AA = GetDlgItemInt(IDC_Q_AA);
	ParamGlobal->q_sep_DF_HZC = (::SendMessage(GetDlgItem(IDC_Q_DF_HZC), BM_GETCHECK, 0, 0) & 1);
	ParamGlobal->q_sep_DF_HZ = GetDlgItemInt(IDC_Q_DF_HZ);
	ParamGlobal->q_sep_DF_MFSC = (::SendMessage(GetDlgItem(IDC_Q_DF_MFSC), BM_GETCHECK, 0, 0) & 1);
	ParamGlobal->q_sep_DF_MFS = GetDlgItemInt(IDC_Q_DF_MFS);
	ParamGlobal->q_sep_DF_PRIFAST = (::SendMessage(GetDlgItem(IDC_Q_DF_PRIFAST), BM_GETCHECK, 0, 0) & 1);
	ParamGlobal->q_sep_FFTFIRLEN = GetDlgItemInt(IDC_Q_FFTFIRLEN);

	unsigned int bt = 0;
	for(int a = 30; a >= 0; a--){
		bt <<= 1;
		if(chkids[a] != -1)
			bt |= (::SendMessage(GetDlgItem(chkids[a]), BM_GETCHECK, 0, 0) & 1);
	};
	ParamGlobal->srates = bt;

	ParamGlobal->srate_free = GetDlgItemInt(IDC_FREQ_FREE);
	ParamGlobal->info_con = (::SendMessage(GetDlgItem(IDC_CON_INFO), BM_GETCHECK, 0, 0) & 1);

	check_setting(ParamGlobal);

	SDialog::CmOk();
}

void
DialogOption::WmCommand(Org_Mes* OrgMes, int wNotifyCode, int wID, HWND hwndCtl)
{
	if(hwndCtl == Quality_hwnd && OrgMes->uMsg == WM_COMMAND && HIWORD(OrgMes->wParam) == CBN_SELCHANGE){
		int setn = Quality->GetCurSel();
		int setAA;
		bool setDF_HZC;
		int setDF_HZ;
		bool setDF_MFSC;
		int setDF_MFS;
		bool setDF_PRIFAST;
		int setFFTFIRLEN;
		if(setn == 0){
			setAA = memo_q_AA;
			setDF_HZC = memo_q_DF_HZC;
			setDF_HZ = memo_q_DF_HZ;
			setDF_MFSC = memo_q_DF_MFSC;
			setDF_MFS = memo_q_DF_MFS;
			setDF_PRIFAST = memo_q_DF_PRIFAST;
			setFFTFIRLEN = memo_q_FFTFIRLEN;
		}else{
			setAA = list_quality_preset[setn * 7 - 7];
			setDF_HZC = list_quality_preset[setn * 7 - 6];
			setDF_HZ = list_quality_preset[setn * 7 - 5];
			setDF_MFSC = list_quality_preset[setn * 7 - 4];
			setDF_MFS = list_quality_preset[setn * 7 - 3];
			setDF_PRIFAST = list_quality_preset[setn * 7 - 2];
			setFFTFIRLEN = list_quality_preset[setn * 7 - 1];
		};
		TCHAR buf[32];
		::SetWindowText(GetDlgItem(IDC_Q_AA), _itot(setAA, buf, 10));
		::SendMessage(GetDlgItem(IDC_Q_DF_HZC), BM_SETCHECK, (setDF_HZC & 1), 0);
		::SetWindowText(GetDlgItem(IDC_Q_DF_HZ), _itot(setDF_HZ, buf, 10));
		::SendMessage(GetDlgItem(IDC_Q_DF_MFSC), BM_SETCHECK, (setDF_MFSC & 1), 0);
		::SetWindowText(GetDlgItem(IDC_Q_DF_MFS), _itot(setDF_MFS, buf, 10));
		::SendMessage(GetDlgItem(IDC_Q_DF_PRIFAST), BM_SETCHECK, (setDF_PRIFAST & 1), 0);
		::SetWindowText(GetDlgItem(IDC_Q_FFTFIRLEN), _itot(setFFTFIRLEN, buf, 10));
		return;
	};

	SDialog::WmCommand(OrgMes, wNotifyCode, wID, hwndCtl);
}

void check_setting(PARAM_GLOBAL* pm)
{
	const int list_freq[] = {
		  1000,     -1,   1500, 
		  2000,     -1,   3000, 
		  4000,     -1,   6000, 
		  8000,  11025,  12000, 
		 16000,  22050,  24000, 
		 32000,  44100,  48000, 
		 64000,  88200,  96000, 
		128000, 176400, 192000, 
		256000, 352800, 384000, 
		512000, 705600, 768000
	};
	int ff = pm->srate_free;
	if(ff < 0)
		ff = 0;
	pm->srate_free = ff;
	int bfs = pm->srates;
	if((bfs & 1) != 0){
		int bt = 2;
		for(int n = 0; n < 30; n++, bt += bt){
			if(ff == list_freq[n]){
				bfs |= bt;
				bfs &= -2;
				break;
			};
		};
	};
	if(bfs == 0)
		bfs = 0x40000;
	pm->srates = bfs;
	int t;
	t = pm->q_sep_AA;
	if(t < 0)
		t = 0;
	pm->q_sep_AA = t;
	t = pm->q_sep_DF_HZ;
	if(t < 1)
		t = 1;
	pm->q_sep_DF_HZ = t;
	t = pm->q_sep_DF_MFS;
	if(t < 1)
		t = 1;
	pm->q_sep_DF_MFS = t;
	t = pm->q_sep_DF_HZC;
	if(!(t || pm->q_sep_DF_MFSC))
		t = 1;
	pm->q_sep_DF_HZC = t;
	t = pm->q_sep_FFTFIRLEN;
	if(t < 1)
		t = 1;
	{
		int n = 0;
		while(t != 1){
			t >>= 1;
			n++;
		};
		t <<= n;
	};
	pm->q_sep_FFTFIRLEN = t;
}
